/*** BitReader */
/* 32+8bitΥХåեˤᤤäѤɤǤ, ڤꤹ */
#include "bitReader.h"

void BitReader_init(BitReader_t this, byte *buf, uint size, Png_t png)
{
  this->p = buf;
  this->upper = buf + size;
  this->total = 0;
  this->len = 0;
  this->buf = this->buf2 = 0;
  this->png = png;
}

/* ХåեߤlenӥåȰʾˤʤޤɤ߹ */
/* 40ӥåȤΥХåեȤΤ, Хåեnӥå(0<n<8)
 * ĤäƤȤ25+nӥåȰʾgetBits뤿 */
static int fillBuffer(BitReader_t this, int len)
{
  while (this->len < len) {
    if (! this->p)		/* ⤦ǡʤ */
      return SZL_BUF_ERROR;
    if (this->p >= this->upper) {
      int size;
      this->p = Png_getNextIdat(this->png, &size);
      this->upper = this->p + size;
      continue;
    }
    this->buf |= *this->p << this->len;
    this->len += 8;
    if (this->len > 32)
      this->buf2 = *this->p >> (this->len - 32);
    this->p++;
    this->total++;
  }
  return SZL_OK;
}

/* Хåե (buf2:buf) ̤lenӥåȤΤƤ */
static inline void discardBits(BitReader_t this, int len)
{
  this->buf >>= len;
  this->len -= len;
  if (this->len > 32 - len) {
    this->buf |= this->buf2 << (32 - len);
    this->buf2 >>= len;
  }
}

int BitReader_getBits(BitReader_t this, int len, int *x)
{
  int ret = SZL_OK;
  if (len > this->len)
    ret = fillBuffer(this, len);
  if (ret == SZL_OK) {
    *x = this->buf & ((1 << len) - 1);
    discardBits(this, len);
  }
  return ret;
}

int BitReader_peekBits(BitReader_t this, int len, int *x)
{
  if (len > this->len)
    if (fillBuffer(this, len) != SZL_OK)
      len = this->len;
  *x = this->buf & ((1 << len) - 1);
  return SZL_OK;
}

int BitReader_getByte(BitReader_t this, int *x)
{
  int ret = SZL_OK;
  /* Хȶޤǿʤ */
  if (this->len & 7)
    discardBits(this, this->len & 7);
  if (this->len < 8)
    ret = fillBuffer(this, 8);
  *x = (byte)this->buf;
  discardBits(this, 8);
  return ret;
}

uint BitReader_getTotal(BitReader_t this)
{
  return this->total;
}
